# A simple Hash class which can effectively fake-out an Object by
# accessing values using the method names as keys

class HashWithMethodAccess < Hash
 def method_missing(symbol)
   self[symbol] || super
 end
 
 # specifically override the #id method. If you want the actual ID
 # of this object, use #object_id instead.
 
 def id
   self[:id]
 end
end


#* are there any inherent flaws in this approach? Obvious ones would be
#that methods that *do* exist on Hash will be called rather than
#accessing the keys, i.e.
#
# h = HashWithMethodAccess.new
# h[:update] = 1
# h.update # => ArgumentError
#
#Another might be that if you want to do this sort of thing, use
#OpenStruct instead...