                                                                     
                                                                     
                                                                     
                                             
require 'amb'
require 'set'
module Enumerable
  def sum
    self.inject(0) { |t,i| t + i }
  end
end

class PossibleSums
  @@groupings_cache = { }
  @@possibilities_cache = { }

  def groupings_cache
    @@groupings_cache
  end

  def possibilities_cache
    @@possibilities_cache
  end

  attr_accessor :target, :places, :available, :amb

  def initialize(target, places, available = (1..9), amb = nil)
    self.amb       = amb || Amb.new
    self.target    = target
    self.places    = places
    self.available = available.sort.select { |a| a <= target - places * (places - 1) / 2 }
  end

  def calculate
    self.possible_numbers
  end

  def possible_numbers
    possibilities_cache[key] ||=
      if not_enough_numbers_available? || target_too_big? || target_too_small?
        Set.new
      elsif just_right?
        Set.new(available)
      else
        self.possible_sums.inject(Set.new) { |a, e| a.merge(e) }
      end
  end

  def target_too_big?
    available[-places,places].sum < target
  end

  def target_too_small?
    available[0, places].sum > target
  end

  def not_enough_numbers_available?
    available.size < places
  end

  def just_right?
    available.size == places && available.sum == target
  end

  def possible_sums
    groupings_cache[key] ||=
      case available.size
      when 0
        []
      when available.last
        all_sums
      else
        sums_for_full_range.select { |e| (e - available).empty? }
      end
  end

  def sums_for_full_range
    PossibleSums.new(target, places, 1..available.max, amb).possible_sums
  end


  def sums_after_removing(val)
    PossibleSums.new(target - val, places - 1, available.select { |i| i > val },
                     amb).possible_sums
  end


  def all_sums
    amb.all_values do |amb|
      case places
      when 1
        amb.assert(available.include?(target))
        Set.new([target])
      when available.size
        amb.assert(available.sum == target)
        Set.new(available)
      else
        amb.deny((available.size < places) &&
                 places.zero? &&
                 (available[-places, places].sum < target) &&
                 (available[0, places].sum > target ))
        val = amb.one_of(available)
        Set.new([val]) + amb.one_of(sums_after_removing(val))
      end
    end
  end

  def key
    [target, places, available]
  end
end
