class Module
  def morph_accessor(sym)
    field = sym.to_s.chomp('=')

    class_eval ""+
      "def #{field}=(val)\n"+
      "  @#{field} = val\n"+
      "end\n"+
      "def #{field}\n"+
      "  @#{field} = nil unless @#{field}\n"+
      "  @#{field}\n"+
      "end\n"
  end
end

module Morph
  def method_missing sym, *args
    self.class.morph_accessor sym
    send(sym, *args)
  end

  def my_methods
    methods.delete_if do |m|
      Module.respond_to? m or
      m == 'method_missing' or
      m == 'my_methods'
    end.sort
  end
end