class ProbabilityVector
    def initialize
      @scores = Hash.new(1.0)
    end

    def multiply( category, multiplier )
      @scores[category] = @scores[category] * multiplier
    end
  
    def normalised
      total = @scores.values.inject(0.0) { |total, score| total + score }
      return hash_map( @scores ) { |score| score / total }
    end
  
    def likely
      highest = @scores.values.inject(0.0) do |highest, score|
        score > highest ? score : highest
      end
      return @scores.keys.select do |category|
        yield( @scores[category], highest )
      end
    end
    
    def close_enough_to_highest?( score, highest )
      score > 0.5 * highest
    end
    
    private
      def hash_map( hash )
        mapped = {}
        hash.each do |key, value|
            mapped[key] = yield( value )
        end
        return mapped
      end
end
